Index: branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/cla.F90
===================================================================
--- branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/cla.F90	(revision 2391)
+++ branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/cla.F90	(revision 2392)
@@ -63,716 +111,632 @@
       !!      at some straits ( Bab el Mandeb, Gibraltar, Hormuz ).
       !!
-      !! ** Method  :   ...
-      !!         Add this trend now to the general trend of tracer (ta,sa):
-      !!            (ta,sa) = (ta,sa) + ( zta , zsa )
-      !!
-      !! ** Action  :   update (ta,sa) with the now advective tracer trends
-      !!
-      !! History :
-      !!        !         (A. Bozec)  original code  
-      !!   8.5  !  02-11  (A. Bozec)  F90: Free form and module
-      !!----------------------------------------------------------------------
-      !! * Arguments
+      !! ** Method  :   using both imposed transport at each strait and T & S
+      !!              budget, the now tracer trends is updated
+      !!
+      !! ** Action  :   (ta,sa)   updated now tracer trends at cla straits
+      !!----------------------------------------------------------------------
       INTEGER, INTENT( in ) ::   kt         ! ocean time-step index
       !!----------------------------------------------------------------------
- 
-      ! Bab el Mandeb strait horizontal advection
-
-      CALL tra_bab_el_mandeb 
-
-      ! Gibraltar strait horizontal advection
-
-      CALL tra_gibraltar
-
-      ! Hormuz Strait ( persian Gulf) horizontal advection
-
-      CALL tra_hormuz 
-
-   END SUBROUTINE tra_cla
-
-
-   SUBROUTINE tra_bab_el_mandeb
+      !
+      IF( kt == nit000 ) THEN 
+         IF(lwp) WRITE(numout,*)
+         IF(lwp) WRITE(numout,*) 'tra_cla : cross land advection on tracers '
+         IF(lwp) WRITE(numout,*) '~~~~~~~~'
+      ENDIF
+      !
+      IF( nbab == 1    )   CALL cla_bab_el_mandeb('tra')      ! Bab el Mandeb strait
+      IF( ngib == 1    )   CALL cla_gibraltar    ('tra')      ! Gibraltar strait
+      IF( nhor == 1    )   CALL cla_hormuz       ('tra')      ! Hormuz Strait ( Persian Gulf)
+      !
+   END SUBROUTINE cla_traadv
+
+   
+   SUBROUTINE cla_dynspg( kt )
+      !!----------------------------------------------------------------------
+      !!                 ***  ROUTINE cla_dynspg  ***
+      !!                   
+      !! ** Purpose :   Update the after velocity at some straits 
+      !!              (Bab el Mandeb, Gibraltar, Hormuz).
+      !!
+      !! ** Method  :   required to compute the filtered surface pressure gradient 
+      !!
+      !! ** Action  :   (ua,va)   after velocity at the cla straits
+      !!----------------------------------------------------------------------
+      INTEGER, INTENT( in ) ::   kt         ! ocean time-step index
+      !!----------------------------------------------------------------------
+      !
+      IF( kt == nit000 ) THEN 
+         IF(lwp) WRITE(numout,*)
+         IF(lwp) WRITE(numout,*) 'cla_dynspg : cross land advection on (ua,va) '
+         IF(lwp) WRITE(numout,*) '~~~~~~~~~~'
+      ENDIF
+      !
+      IF( nbab == 1    )   CALL cla_bab_el_mandeb('spg')      ! Bab el Mandeb strait
+      IF( ngib == 1    )   CALL cla_gibraltar    ('spg')      ! Gibraltar strait
+      IF( nhor == 1    )   CALL cla_hormuz       ('spg')      ! Hormuz Strait ( Persian Gulf)
+      !
+!!gm lbc is needed here, not?
+!!gm      CALL lbc_lnk( hdivn, 'U', -1. )   ;   CALL lbc_lnk( hdivn, 'V', -1. )      ! Lateral boundary conditions 
+      !
+   END SUBROUTINE cla_dynspg
+
+
+   SUBROUTINE cla_init
+      !! -------------------------------------------------------------------
+      !!                   ***  ROUTINE cla_init  ***
+      !!           
+      !! ** Purpose :   control check for mpp computation  
+      !!
+      !! ** Method  : - All the strait grid-points must be inside one of the 
+      !!              local domain interior for the cla advection to work
+      !!              properly in mpp (i.e. inside (2:jpim1,2:jpjm1) ).
+      !!              Define the corresponding indicators (nbab, ngib, nhor)
+      !!              - The profiles of cross-land fluxes are currently hard
+      !!              coded for L31 levels. Stop if jpk/=31
+      !!
+      !! ** Action  :   nbab, ngib, nhor   strait inside the local domain or not
       !!---------------------------------------------------------------------
-      !!             ***  ROUTINE tra_bab_el_mandeb  ***
-      !!
-      !! ** Purpose :   Update the horizontal advective trend of tracers
-      !!      correction in Bab el Mandeb strait and
-      !!      add it to the general trend of tracer equations.
+      REAL(wp) ::   ztemp
+      !!---------------------------------------------------------------------
+      !
+      IF(lwp) WRITE(numout,*)
+      IF(lwp) WRITE(numout,*) 'cla_init : cross land advection initialisation '
+      IF(lwp) WRITE(numout,*) '~~~~~~~~~'
+      !
+      IF( .NOT.lk_dynspg_flt )   CALL ctl_stop( 'cla_init: Cross Land Advection works only with lk_dynspg_flt=T ' )
+      !
+      IF( lk_vvl    )   CALL ctl_stop( 'cla_init: Cross Land Advection does not work with lk_vvl=T option' )
+      !
+      IF( jpk /= 31 )   CALL ctl_stop( 'cla_init: Cross Land Advection hard coded for ORCA_R2_L31' )
+      !
+      !                                        _|_______|_______|_
+      !                                     89  |       |///////|  
+      !                                        _|_______|_______|_
+      ! ------------------------ !          88  |///////|       | 
+      !   Bab el Mandeb strait   !             _|_______|_______|_
+      ! ------------------------ !          87  |///////|       | 
+      !                                        _|_______|_______|_
+      !                                         |  160  |  161  |  
+      !
+      ! The 6 Bab el Mandeb grid-points must be inside one of the interior of the
+      ! local domain for the cla advection to work properly (i.e. (2:jpim1,2:jpjm1)
+      nbab = 0
+      IF(  ( 1 <= mj0( 88) .AND. mj1( 89) <= jpj ) .AND.    &  !* (161,89), (161,88) and (161,88) on the local pocessor
+         & ( 1 <= mi0(160) .AND. mi1(161) <= jpi )       )    nbab = 1 
+      !
+      ! test if there is no local domain that includes all required grid-points
+      ztemp = REAL( nbab )
+      IF( lk_mpp )   CALL mpp_sum( ztemp )      ! sum with other processors value
+      IF( ztemp == 0 ) THEN                     ! Only 2 points in each direction, this should never be a problem
+         CALL ctl_stop( ' cross land advection at Bab-el_Mandeb does not work with your processor cutting: change it' )
+      ENDIF
+      !                                        ___________________________
+      ! ------------------------ !         102  |       |///////|       |
+      !     Gibraltar strait     !             _|_______|_______|_______|_
+      ! ------------------------ !         101  |       |///////|       |
+      !                                        _|_______|_______|_______|_ 
+      !                                         |  139  |  140  |  141  |
+      !
+      ! The 6 Gibraltar grid-points must be inside one of the interior of the
+      ! local domain for the cla advection to work properly (i.e. (2:jpim1,2:jpjm1)
+      ngib = 0
+      IF(  ( 2 <= mj0(101) .AND. mj1(102) <= jpjm1 ) .AND.    &  !* (139:141,101:102) on the local pocessor
+         & ( 2 <= mi0(139) .AND. mi1(141) <= jpim1 )       )    ngib = 1 
+      !
+      ! test if there is no local domain that includes all required grid-points
+      ztemp = REAL( ngib )
+      IF( lk_mpp )   CALL mpp_sum( ztemp )      ! sum with other processors value
+      IF( ztemp == 0 ) THEN                     ! 3 points in i-direction, this may be a problem with some cutting
+           CALL ctl_stop( ' cross land advection at Gibraltar does not work with your processor cutting: change it' )
+      ENDIF
+      !                                        _______________
+      ! ------------------------ !          94  |/////|     | 
+      !       Hormuz strait      !             _|_____|_____|_
+      ! ------------------------ !                171   172     
+      !           
+      ! The 2 Hormuz grid-points must be inside one of the interior of the
+      ! local domain for the cla advection to work properly (i.e. (2:jpim1,2:jpjm1)
+      nhor = 0
+      IF(    2 <= mj0( 94) .AND. mj1( 94) <= jpjm1  .AND.  & 
+         &   2 <= mi0(171) .AND. mi1(172) <= jpim1         )   nhor = 1 
+      !
+      ! test if there is no local domain that includes all required grid-points
+      ztemp = REAL( nhor )
+      IF( lk_mpp )   CALL mpp_sum( ztemp )      ! sum with other processors value
+      IF( ztemp == 0 ) THEN                     ! 3 points in i-direction, this may be a problem with some cutting
+           CALL ctl_stop( ' cross land advection at Hormuz does not work with your processor cutting: change it' )
+      ENDIF
+      !
+   END SUBROUTINE cla_init
+
+
+   SUBROUTINE cla_bab_el_mandeb( cd_td )
+      !!----------------------------------------------------------------------
+      !!                ***  ROUTINE cla_bab_el_mandeb  ***
+      !!       
+      !! ** Purpose :   update the now horizontal divergence, the tracer tendancy
+      !!              and the after velocity in vicinity of Bab el Mandeb ( Red Sea - Indian ocean).
+      !!
+      !! ** Method  :   compute the exchanges at each side of the strait :
+      !!
+      !!       surf. zio_flow
+      !! (+ balance of emp) /\  |\\\\\\\\\\\|
+      !!                    ||  |\\\\\\\\\\\|  
+      !!    deep zio_flow   ||  |\\\\\\\\\\\|  
+      !!            |  ||   ||  |\\\\\\\\\\\|  
+      !!        89  |  ||   ||  |\\\\\\\\\\\|  
+      !!            |__\/_v_||__|____________ 
+      !!            !\\\\\\\\\\\|          surf. zio_flow
+      !!            |\\\\\\\\\\\|<===    (+ balance of emp)
+      !!            |\\\\\\\\\\\u
+      !!        88  |\\\\\\\\\\\|<---      deep  zrecirc (upper+deep at 2 different levels)
+      !!            |___________|__________   
+      !!            !\\\\\\\\\\\|         
+      !!            |\\\\\\\\\\\| ---\     deep  zrecirc (upper+deep) 
+      !!        87  !\\\\\\\\\\\u ===/   + deep  zio_flow   (all at the same level)
+      !!            !\\\\\\\\\\\|  
+      !!            !___________|__________ 
+      !!                160         161
+      !!
+      !!----------------------------------------------------------------------
+      CHARACTER(len=1), INTENT(in) ::   cd_td   ! ='div' update the divergence
+      !                                         ! ='tra' update the tracers
+      !                                         ! ='spg' update after velocity
+      INTEGER  ::   ji, jj, jk   ! dummy loop indices
+      REAL(wp) ::   zemp_red     ! temporary scalar
+      REAL(wp) ::   zio_flow, zrecirc_upp, zrecirc_mid, zrecirc_bot
+      !!---------------------------------------------------------------------
+      !
+      SELECT CASE( cd_td ) 
+      !                     ! ---------------- !
+      CASE( 'ini' )         !  initialisation  ! 
+         !                  ! ---------------- ! 
+         !                                   
+         zio_flow    = 0.4e6                       ! imposed in/out flow
+         zrecirc_upp = 0.2e6                       ! imposed upper recirculation water
+         zrecirc_bot = 0.5e6                       ! imposed bottom  recirculation water
+
+         hdiv_161_88(:) = 0.e0                     ! (161,88) Gulf of Aden side, north point
+         hdiv_161_87(:) = 0.e0                     ! (161,87) Gulf of Aden side, south point
+         hdiv_160_89(:) = 0.e0                     ! (160,89) Red sea side
+
+         DO jj = mj0(88), mj1(88)              !** profile of hdiv at (161,88)   (Gulf of Aden side, north point)
+            DO ji = mi0(161), mi1(161)         !------------------------------
+               DO jk = 1, 8                        ! surface in/out flow   (Ind -> Red)   (div >0)
+                  hdiv_161_88(jk) = + zio_flow / ( 8. * e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
+               END DO
+               !                                   ! recirculation water   (Ind -> Red)   (div >0)
+               hdiv_161_88(20) =                 + zrecirc_upp   / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,20) )
+               hdiv_161_88(21) = + ( zrecirc_bot - zrecirc_upp ) / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,21) )
+            END DO
+         END DO
+         !
+         DO jj = mj0(87), mj1(87)              !** profile of hdiv at (161,88)   (Gulf of Aden side, south point)
+            DO ji = mi0(161), mi1(161)         !------------------------------
+               !                                   ! deep out flow + recirculation   (Red -> Ind)   (div <0)
+               hdiv_161_87(21) = - ( zio_flow + zrecirc_bot ) / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,21) )
+            END DO
+         END DO
+         !
+         DO jj = mj0(89), mj1(89)              !** profile of hdiv at (161,88)   (Red sea side)
+            DO ji = mi0(160), mi1(160)         !------------------------------
+               DO jk = 1, 8                        ! surface inflow    (Ind -> Red)   (div <0)
+                  hdiv_160_89(jk) = - zio_flow / ( 8. * e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
+               END DO
+               !                                   ! deep    outflow   (Red -> Ind)   (div >0)
+               hdiv_160_89(16)    = + zio_flow / (      e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,16) )
+            END DO
+         END DO
+         !                  ! ---------------- !
+      CASE( 'div' )         !   update hdivn   ! (call by divcur module)
+         !                  ! ---------=====-- ! 
+         !                                     !** emp on the Red Sea   (div >0) 
+         zemp_red = 0.e0                       !---------------------
+         DO jj = mj0(87), mj1(96)                  ! sum over the Red sea
+            DO ji = mi0(148), mi1(160) 
+               zemp_red = zemp_red + emp(ji,jj) * e1t(ji,jj) * e2t(ji,jj) * tmask_i(ji,jj)
+            END DO
+         END DO
+         IF( lk_mpp )   CALL mpp_sum( zemp_red )   ! sum with other processors value
+         zemp_red = zemp_red * 1.e-3               ! convert in m3
+         !
+         !                                     !** Correct hdivn (including emp adjustment)
+         !                                     !-------------------------------------------
+         DO jj = mj0(88), mj1(88)                  !* profile of hdiv at (161,88)   (Gulf of Aden side, north point)
+            DO ji = mi0(161), mi1(161) 
+               hdiv_161_88_kt(:) = hdiv_161_88(:)
+               DO jk = 1, 8                              ! increase the inflow from the Indian   (div >0) 
+                  hdiv_161_88_kt(jk) = hdiv_161_88(jk) + zemp_red / (8. * e2u(ji,jj) * fse3u(ji,jj,jk) )
+               END DO
+               hdivn(ji,jj,:) = hdivn(ji,jj,:) + hdiv_161_88_kt(:)
+            END DO
+         END DO
+         DO jj = mj0(87), mj1(87)                  !* profile of divergence at (161,87)   (Gulf of Aden side, south point)
+            DO ji = mi0(161), mi1(161) 
+               hdivn(ji,jj,:) = hdivn(ji,jj,:) + hdiv_161_87(:)
+            END DO
+         END DO
+         DO jj = mj0(89), mj1(89)                  !* profile of divergence at (160,89)   (Red sea side)
+            DO ji = mi0(160), mi1(160) 
+               hdiv_160_89_kt(:) = hdiv_160_89(:)
+               DO jk = 1, 18                              ! increase the inflow from the Indian   (div <0) 
+                  hdiv_160_89_kt(jk) = hdiv_160_89(jk) - zemp_red / (10. * e1v(ji,jj) * fse3v(ji,jj,jk) )
+               END DO
+               hdivn(ji, jj,:) = hdivn(ji, jj,:) + hdiv_160_89_kt(:)
+            END DO
+         END DO
+         !                  ! ---------------- !
+      CASE( 'tra' )         !  update (ta,sa)  ! (call by traadv module)
+         !                  ! --------=======- !
+         !
+         DO jj = mj0(88), mj1(88)              !** (161,88)   (Gulf of Aden side, north point)
+            DO ji = mi0(161), mi1(161) 
+               DO jk = 1, jpkm1                         ! surf inflow + reciculation (from Gulf of Aden)
+                  ta(ji,jj,jk) = ta(ji,jj,jk) - hdiv_161_88_kt(jk) * tn(ji,jj,jk)
+                  sa(ji,jj,jk) = sa(ji,jj,jk) - hdiv_161_88_kt(jk) * sn(ji,jj,jk)
+               END DO
+            END DO
+         END DO
+         DO jj = mj0(87), mj1(87)              !** (161,87)   (Gulf of Aden side, south point)
+            DO ji = mi0(161), mi1(161) 
+               jk =  21                                 ! deep outflow + recirulation (combined flux)
+               ta(ji,jj,jk) = ta(ji,jj,jk) + hdiv_161_88(20) * tn(ji  ,jj+1,20)   &  ! upper recirculation from Gulf of Aden
+                  &                        + hdiv_161_88(21) * tn(ji  ,jj+1,21)   &  ! deep  recirculation from Gulf of Aden
+                  &                        + hdiv_160_89(16) * tn(ji-1,jj+2,16)      ! deep inflow from Red sea
+               sa(ji,jj,jk) = sa(ji,jj,jk) + hdiv_161_88(20) * sn(ji  ,jj+1,20)   &
+                  &                        + hdiv_161_88(21) * sn(ji  ,jj+1,21)   &
+                  &                        + hdiv_160_89(16) * sn(ji-1,jj+2,16)   
+            END DO
+         END DO
+         DO jj = mj0(89), mj1(89)              !** (161,88)   (Red sea side)
+            DO ji = mi0(160), mi1(160)
+               DO jk = 1, 14                            ! surface inflow (from Gulf of Aden)
+                  ta(ji,jj,jk) = ta(ji,jj,jk) - hdiv_160_89_kt(jk) * tn(ji+1,jj-1,jk)
+                  sa(ji,jj,jk) = sa(ji,jj,jk) - hdiv_160_89_kt(jk) * sn(ji+1,jj-1,jk)
+               END DO
+               !                                        ! deep    outflow (from Red sea)
+               ta(ji,jj,16) = ta(ji,jj,16) - hdiv_160_89(jk) * tn(ji,jj,jk)
+               sa(ji,jj,16) = sa(ji,jj,16) - hdiv_160_89(jk) * sn(ji,jj,jk)
+            END DO
+         END DO
+         !
+         !                  ! ---------------- !
+      CASE( 'spg' )         !  update (ua,va)  ! (call by dynspg module)
+         !                  ! --------=======- !
+         ! at this stage, (ua,va) are the after velocity, not the tendancy
+         ! compute the velocity from the divergence at T-point
+         !
+         DO jj = mj0(88), mj1(88)              !** (160,88)   (Gulf of Aden side, north point)
+            DO ji = mi0(160), mi1(160)                   ! 160, not 161 as it is a U-point) 
+               ua(ji,jj,:) = - hdiv_161_88_kt(:) / ( e1t(ji+1,jj) * e2t(ji+1,jj) * fse3t(ji+1,jj,:) )   &
+                  &                              * e2u(ji,jj) * fse3u(ji,jj,:)
+            END DO
+         END DO
+         DO jj = mj0(87), mj1(87)              !** (160,87)   (Gulf of Aden side, south point)
+            DO ji = mi0(160), mi1(160)                   ! 160, not 161 as it is a U-point) 
+               ua(ji,jj,:) = - hdiv_161_87(:) / ( e1t(ji+1,jj) * e2t(ji+1,jj) * fse3t(ji+1,jj,:) )   &
+                  &                           * e2u(ji,jj) * fse3u(ji,jj,:)
+            END DO
+         END DO
+         DO jj = mj0(88), mj1(88)              !** profile of divergence at (160,89)   (Red sea side)
+            DO ji = mi0(160), mi1(160)                   ! 88, not 89 as it is a V-point)
+               va(ji,jj,:) = - hdiv_160_89_kt(:) / ( e1t(ji,jj+1) * e2t(ji,jj+1) * fse3t(ji,jj+1,:) )   &
+                  &                              * e1v(ji,jj) * fse3v(ji,jj,:)
+            END DO
+         END DO
+      END SELECT
+      !
+   END SUBROUTINE cla_bab_el_mandeb
+   
+
+   SUBROUTINE cla_gibraltar( cd_td )
+      !! -------------------------------------------------------------------
+      !!                 ***  ROUTINE cla_gibraltar  ***
+      !!        
+      !! ** Purpose :   update the now horizontal divergence, the tracer 
+      !!              tendancyand the after velocity in vicinity of Gibraltar 
+      !!              strait ( Persian Gulf - Indian ocean ).
       !!
       !! ** Method :
-      !!     We impose transport at Bab el Mandeb and knowing T and S in
-      !!     surface and depth at each side of the  strait, we deduce T and S
-      !!     of the deep outflow of the Red Sea in the Indian ocean . 
-      !!                                          |
-      !!            |/ \|            N          |\ /|
-      !!            |_|_|______      |          |___|______
-      !!        88  |   |<-       W - - E    88 |   |<-
-      !!        87  |___|______      |       87 |___|->____
-      !!             160 161         S           160 161 
-      !!       horizontal view                horizontal view
-      !!          surface                        depth
-      !!    
-      !!     The horizontal advection is evaluated by a second order cen-
-      !!     tered scheme using now fields (leap-frog scheme). In specific
-      !!     areas (vicinity of major river mouths, some straits, or tn
-      !!     approaching the freezing point) it is mixed with an upstream 
-      !!     scheme for stability reasons. 
-      !!
-      !!         C A U T I O N : the trend saved is the centered trend only.
-      !!      It doesn't take into account the upstream part of the scheme.
-      !!
-      !! ** history :
-      !!           !  02-11  (A. Bozec) Original code 
-      !!      8.5  !  02-11  (A. Bozec) F90: Free form and module
+      !!                     _______________________            
+      !!      deep  zio_flow /====|///////|====> surf. zio_flow
+      !!    + deep  zrecirc  \----|///////|     (+balance of emp)
+      !! 102                      u///////u
+      !!      mid.  recicul    <--|///////|<==== deep  zio_flow
+      !!                     _____|_______|_____  
+      !!      surf. zio_flow ====>|///////|       
+      !!    (+balance of emp)     |///////|
+      !! 101                      u///////|             
+      !!      mid.  recicul    -->|///////|               Caution: zrecirc split into 
+      !!      deep  zrecirc  ---->|///////|                  upper & bottom recirculation
+      !!                   _______|_______|_______ 
+      !!                     139     140     141  
+      !!
       !!---------------------------------------------------------------------
-      !! * Local declarations
-      INTEGER ::  ji, jj, jk               ! dummy loop indices
-      REAL(wp) :: zsu, zvt
-      REAL(wp) :: zsumt, zsumt1, zsumt2, zsumt3, zsumt4
-      REAL(wp) :: zsums, zsums1, zsums2, zsums3, zsums4
-      REAL(wp) :: zt, zs
-      REAL(wp) :: zwei
-      REAL(wp), DIMENSION (jpk) ::  zu1_rs, zu2_rs, zu3_rs
+      CHARACTER(len=1), INTENT(in) ::   cd_td   ! ='div' update the divergence
+      !                                         ! ='tra' update the tracers
+      !                                         ! ='spg' update after velocity
+      INTEGER  ::   ji, jj, jk   ! dummy loop indices
+      REAL(wp) ::   zemp_med     ! temporary scalar
+      REAL(wp) ::   zio_flow, zrecirc_upp, zrecirc_mid, zrecirc_bot
       !!---------------------------------------------------------------------
-
-      ! Initialization of vertical sum for T and S transport
-      ! ----------------------------------------------------
-
-      zsumt  = 0.e0       ! East  Bab el Mandeb surface north point (T)
-      zsums  = 0.e0       ! East  Bab el Mandeb surface north point (S)
-      zsumt1 = 0.e0       ! East  Bab el Mandeb depth   south point (T)
-      zsums1 = 0.e0       ! East  Bab el Mandeb depth   south point (S)
-      zsumt2 = 0.e0       ! West  Bab el Mandeb surface             (T)
-      zsums2 = 0.e0       ! West  Bab el Mandeb surface             (S)
-      zsumt3 = 0.e0       ! West  Bab el Mandeb depth               (T)
-      zsums3 = 0.e0       ! West  Bab el Mandeb depth               (S)
-      zsumt4 = 0.e0       ! East  Bab el Mandeb depth   north point (T) 
-      zsums4 = 0.e0       ! East  Bab el Mandeb depth   north point (S) 
-      
-      ! EMP of the Red Sea 
-      ! ------------------
-
-      zempred = 0.e0
-      zwei = 0.e0
-      DO jj = mj0(87), mj1(96)
-         DO ji = mi0(148), mi1(160)
-            zwei    = tmask(ji,jj,1) * e1t(ji,jj) * e2t(ji,jj)
-            zempred = zempred + ( emp(ji,jj) - rnf(ji,jj) ) * zwei 
-         END DO
-      END DO
-      IF( lk_mpp )   CALL mpp_sum( zempred )      ! sum with other processors value
-
-      ! convert in m3
-      zempred = zempred * 1.e-3
-
-      ! Velocity profile at each point
-      ! ------------------------------
-
-      zu1_rs(:) = zu1_rs_i(:)
-      zu2_rs(:) = zu2_rs_i(:)
-      zu3_rs(:) = zu3_rs_i(:)
-
-      ! velocity profile at 161,88 East Bab el Mandeb North point 
-      ! we imposed zisw_rs + EMP above the Red Sea 
-      DO jk = 1, 8                                      
-         DO jj = mj0(88), mj1(88) 
-            DO ji = mi0(160), mi1(160) 
-               zu1_rs(jk) = zu1_rs(jk) - ( zempred / 8. ) / ( e2u(ji,jj) * fse3u(ji,jj,jk) )     
-            END DO
-         END DO
-      END DO
-
-      ! velocity profile at 161, 88 West Bab el Mandeb 
-      ! we imposed zisw_rs + EMP above the Red Sea 
-      DO jk = 1,  10                                     
-         DO jj = mj0(88), mj1(88) 
-            DO ji = mi0(160), mi1(160) 
-               zu3_rs(jk) = zu3_rs(jk) + ( zempred / 10. ) / ( e1v(ji,jj) * fse3v(ji,jj,jk) )
-            END DO
-         END DO
-      END DO
-      
-      ! Balance of temperature and salinity
-      ! -----------------------------------
-
-      ! east Bab el Mandeb surface vertical sum of transport* S,T
-      DO jk =  1, 19
-         DO jj = mj0(88), mj1(88) 
-            DO ji = mi0(161), mi1(161) 
-               zsumt  = zsumt  + tn(ji,jj,jk) * e2u(ji-1,jj) * fse3u(ji-1,jj,jk) * zu1_rs(jk)  
-               zsums  = zsums  + sn(ji,jj,jk) * e2u(ji-1,jj) * fse3u(ji-1,jj,jk) * zu1_rs(jk) 
-            END DO
-         END DO
-      END DO
-
-      ! west Bab el Mandeb surface vertical sum of transport* S,T
-      DO jk =  1, 10
-         DO jj = mj0(88), mj1(88) 
-            DO ji = mi0(161), mi1(161) 
-               zsumt2 = zsumt2 + tn(ji,jj,jk) * e1v(ji-1,jj) * fse3v(ji-1,jj,jk) * zu3_rs(jk)
-               zsums2 = zsums2 + sn(ji,jj,jk) * e1v(ji-1,jj) * fse3v(ji-1,jj,jk) * zu3_rs(jk)
-            END DO
-         END DO
-      END DO
-
-      ! west Bab el Mandeb deeper
-      DO jj = mj0(89), mj1(89) 
-         DO ji = mi0(160), mi1(160) 
-            zsumt3 = tn(ji,jj,16) * e1v(ji,jj-1) * fse3v(ji,jj-1,16) * zu3_rs(16)
-            zsums3 = sn(ji,jj,16) * e1v(ji,jj-1) * fse3v(ji,jj-1,16) * zu3_rs(16)
-         END DO
-      END DO
-
-      ! east  Bab el Mandeb deeper  
-      DO jk =  20, 21
-         DO jj = mj0(88), mj1(88) 
-            DO ji = mi0(161), mi1(161) 
-               zsumt4 =  zsumt4 + tn(ji,jj,jk) * e2u(ji-1,jj) * fse3u(ji-1,jj,jk) * zu1_rs(jk)
-               zsums4 =  zsums4 + sn(ji,jj,jk) * e2u(ji-1,jj) * fse3u(ji-1,jj,jk) * zu1_rs(jk) 
-            END DO
-         END DO
-      END DO
-
-      ! Total transport  
-      zsumt1 = -( zsumt3 + zsumt2 + zsumt + zsumt4 )
-      zsums1 = -( zsums3 + zsums2 + zsums + zsums4 )
-
-      ! Temperature and Salinity at East Bab el Mandeb, Level 21
-      DO jj = mj0(88), mj1(88) 
-         DO ji = mi0(160), mi1(160) 
-            zt = zsumt1 / ( zu2_rs(21) * e2u(ji,jj-1) * fse3u(ji,jj-1,21) )
-            zs = zsums1 / ( zu2_rs(21) * e2u(ji,jj-1) * fse3u(ji,jj-1,21) )
-         END DO
-      END DO
-      
-      ! New Temperature and Salinity at East Bab el Mandeb
-      ! --------------------------------------------------
-
-      ! north point 	
-      DO jk = 1, jpk
-         DO jj = mj0(88), mj1(88) 
-            DO ji = mi0(161), mi1(161) 
-               zvt = e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk)
-               zsu = e2u(ji-1,jj) * fse3u(ji-1,jj,jk)
-               ta(ji,jj,jk) = ta(ji,jj,jk) + ( 1. / zvt ) * zsu * zu1_rs(jk) * tn(ji,jj,jk)
-               sa(ji,jj,jk) = sa(ji,jj,jk) + ( 1. / zvt ) * zsu * zu1_rs(jk) * sn(ji,jj,jk)
-            END DO
-         END DO
-      END DO
-
-      ! south point
-      jk =  21
-      DO jj = mj0(87), mj1(87) 
-         DO ji = mi0(161), mi1(161) 
-            zvt = e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk)
-            zsu = e2u(ji-1,jj) * fse3u(ji-1,jj,jk)
-            ta(ji,jj,jk) = ta(ji,jj,jk) + ( 1. / zvt ) * zsu * zu2_rs(jk) * zt
-            sa(ji,jj,jk) = sa(ji,jj,jk) + ( 1. / zvt ) * zsu * zu2_rs(jk) * zs
-         END DO
-      END DO
-
-
-      ! New Temperature and Salinity at West Bab el Mandeb 
-      ! --------------------------------------------------
-
-      ! surface	
-      DO jk = 1, 10
-         DO jj = mj0(89), mj1(89) 
-            DO ji = mi0(160), mi1(160) 
-               zvt = e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk)
-               zsu = e1v(ji,jj-1) * fse3v(ji,jj-1,jk)
-               ta(ji,jj,jk) = ta(ji,jj,jk) + ( 1. / zvt ) * zsu * zu3_rs(jk) * tn(ji+1,jj-1,jk)
-               sa(ji,jj,jk) = sa(ji,jj,jk) + ( 1. / zvt ) * zsu * zu3_rs(jk) * sn(ji+1,jj-1,jk)
-            END DO
-         END DO
-      END DO
-      ! deeper
-      jk =  16
-      DO jj = mj0(89), mj1(89) 
-         DO ji = mi0(160), mi1(160) 
-            zvt = e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk)
-            zsu = e1v(ji,jj-1) * fse3v(ji,jj-1,jk)
-            ta(ji,jj,jk) = ta(ji,jj,jk) + ( 1. / zvt ) * zsu * zu3_rs(jk) * tn(ji,jj,jk)
-            sa(ji,jj,jk) = sa(ji,jj,jk) + ( 1. / zvt ) * zsu * zu3_rs(jk) * sn(ji,jj,jk)
-         END DO
-      END DO
-
-   END SUBROUTINE tra_bab_el_mandeb
-
-
-   SUBROUTINE tra_gibraltar
+      !
+      SELECT CASE( cd_td ) 
+      !                     ! ---------------- !
+      CASE( 'ini' )         !  initialisation  ! 
+         !                  ! ---------------- ! 
+         !                                     !** initialization of the velocity
+         hdiv_139_101(:) = 0.e0                     !  139,101 (Atlantic side, south point)
+         hdiv_139_102(:) = 0.e0                     !  139,102 (Atlantic side, north point)
+         hdiv_141_102(:) = 0.e0                     !  141,102 (Med sea  side)
+            
+         !                                     !** imposed transport
+         zio_flow    = 0.8e6                        ! inflow surface  water
+         zrecirc_mid = 0.7e6                        ! middle recirculation water
+         zrecirc_upp = 2.5e6                        ! upper  recirculation water
+         zrecirc_bot = 3.5e6                        ! bottom recirculation water
+         !
+         DO jj = mj0(101), mj1(101)            !** profile of hdiv at 139,101 (Atlantic side, south point)
+            DO ji = mi0(139), mi1(139)         !-----------------------------
+               DO jk = 1, 14                        ! surface in/out flow (Atl -> Med)   (div >0)
+                  hdiv_139_101(jk) = + zio_flow / ( 14. * e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
+               END DO
+               DO jk = 15, 20                       ! middle  reciculation (Atl 101 -> Atl 102)   (div >0)   
+                  hdiv_139_101(jk) = + zrecirc_mid / ( 6. * e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
+               END DO
+               !                                    ! upper reciculation (Atl 101 -> Atl 101)   (div >0)
+               hdiv_139_101(21) =               + zrecirc_upp / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
+               !
+               !                                    ! upper & bottom reciculation (Atl 101 -> Atl 101 & 102)   (div >0)
+               hdiv_139_101(22) = ( zrecirc_bot - zrecirc_upp ) / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
+            END DO
+         END DO
+         DO jj = mj0(102), mj1(102)            !** profile of hdiv at 139,102 (Atlantic side, north point)
+            DO ji = mi0(139), mi1(139)         !-----------------------------
+               DO jk = 15, 20                       ! middle reciculation (Atl 101 -> Atl 102)   (div <0)                
+                  hdiv_139_102(jk) = - zrecirc_mid / ( 6. * e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
+               END DO
+               !                                    ! outflow of Mediterranean sea + deep recirculation   (div <0) 
+               hdiv_139_102(22) = - ( zio_flow + zrecirc_bot ) / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
+            END DO
+         END DO
+         DO jj = mj0(102), mj1(102)            !** velocity profile at 141,102  (Med sea side)
+            DO ji = mi0(141), mi1(141)         !------------------------------
+               DO  jk = 1, 14                       ! surface inflow in the Med     (div <0)
+                  hdiv_141_102(jk) = - zio_flow / ( 14. * e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
+               END DO
+               !                                    ! deep    outflow toward the Atlantic    (div >0) 
+               hdiv_141_102(21)    = + zio_flow / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
+            END DO
+         END DO
+         !                  ! ---------------- !
+      CASE( 'div' )         !   update hdivn   ! (call by divcur module)
+         !                  ! ---------=====-- ! 
+         !                                     !** emp on the Mediterranean Sea  (div >0) 
+         zemp_med = 0.e0                       !-------------------------------
+         DO jj = mj0(96), mj1(110)                  ! sum over the Med sea
+            DO ji = mi0(141),mi1(181)
+               zemp_med = zemp_med + emp(ji,jj) * e1t(ji,jj) * e2t(ji,jj) * tmask_i(ji,jj) 
+            END DO
+         END DO
+         DO jj = mj0(96), mj1(96)                   ! minus 2 points in Red Sea 
+            DO ji = mi0(148),mi1(148)
+               zemp_med = zemp_med - emp(ji,jj) * e1t(ji,jj) * e2t(ji,jj) * tmask_i(ji,jj)
+            END DO
+            DO ji = mi0(149),mi1(149)
+               zemp_med = zemp_med - emp(ji,jj) * e1t(ji,jj) * e2t(ji,jj) * tmask_i(ji,jj)
+            END DO
+         END DO
+         IF( lk_mpp )   CALL mpp_sum( zemp_med )    ! sum with other processors value
+         zemp_med = zemp_med * 1.e-3                ! convert in m3
+         !
+         !                                     !** Correct hdivn (including emp adjustment)
+         !                                     !-------------------------------------------
+         DO jj = mj0(101), mj1(101)                 !* 139,101 (Atlantic side, south point)
+            DO ji = mi0(139), mi1(139) 
+               hdiv_139_101_kt(:) = hdiv_139_101(:)      
+               DO jk = 1, 14                              ! increase the inflow from the Atlantic   (div >0) 
+                  hdiv_139_101_kt(jk) = hdiv_139_101(jk) + zemp_med / ( 14. * e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
+               END DO
+               hdivn(ji, jj,:) = hdivn(ji, jj,:) + hdiv_139_101_kt(:)
+            END DO
+         END DO
+         DO jj = mj0(102), mj1(102)                 !* 139,102 (Atlantic side, north point)
+            DO ji = mi0(139), mi1(139) 
+               hdivn(ji,jj,:) = hdivn(ji,jj,:) + hdiv_139_102(:)
+            END DO
+         END DO
+         DO jj = mj0(102), mj1(102)                 !* 141,102 (Med side)
+            DO ji = mi0(141), mi1(141) 
+               hdiv_141_102(:) = hdiv_141_102(:)
+               DO jk = 1, 14                              ! increase the inflow from the Atlantic   (div <0)
+                  hdiv_141_102_kt(jk) = hdiv_141_102(jk) - zemp_med / ( 14. * e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
+               END DO
+               hdivn(ji, jj,:) = hdivn(ji, jj,:) + hdiv_141_102_kt(:)
+            END DO
+         END DO
+         !                  ! ---------------- !
+      CASE( 'tra' )         !  update (ta,sa)  ! (call by traadv module)
+         !                  ! --------=======- !
+         !
+         DO jj = mj0(101), mj1(101)            !** 139,101 (Atlantic side, south point)   (div >0)
+            DO ji = mi0(139), mi1(139) 
+               DO jk = 1, jpkm1                         ! surf inflow + mid. & bottom reciculation (from Atlantic)	
+                  ta(ji,jj,jk) = ta(ji,jj,jk) - hdiv_139_101_kt(jk) * tn(ji,jj,jk)
+                  sa(ji,jj,jk) = sa(ji,jj,jk) - hdiv_139_101_kt(jk) * sn(ji,jj,jk)
+               END DO
+            END DO
+         END DO
+         !
+         DO jj = mj0(102), mj1(102)            !** 139,102 (Atlantic side, north point)   (div <0)
+            DO ji = mi0(139), mi1(139) 
+               DO jk = 15, 20                            ! middle  reciculation (Atl 101 -> Atl 102)   (div <0)
+                  ta(ji,jj,jk) = ta(ji,jj,jk) - hdiv_139_102(jk) * tn(ji,jj-1,jk)  ! middle Atlantic recirculation
+                  sa(ji,jj,jk) = sa(ji,jj,jk) - hdiv_139_102(jk) * sn(ji,jj-1,jk)
+               END DO
+               !                                         ! upper & bottom Atl. reciculation (Atl 101 -> Atl 102) - (div <0)
+               !                                         ! deep Med flow                    (Med 102 -> Atl 102) - (div <0)
+               ta(ji,jj,22) = ta(ji,jj,22) + hdiv_141_102(21) * tn(ji+2,jj  ,21)   &  ! deep Med flow  
+                  &                        + hdiv_139_101(21) * tn(ji  ,jj-1,21)   &  ! upper  Atlantic recirculation  
+                  &                        + hdiv_139_101(22) * tn(ji  ,jj-1,22)      ! bottom Atlantic recirculation  
+               sa(ji,jj,22) = sa(ji,jj,22) + hdiv_141_102(21) * sn(ji+2,jj  ,21)   &
+                  &                        + hdiv_139_101(21) * sn(ji  ,jj-1,21)   &
+                  &                        + hdiv_139_101(22) * sn(ji  ,jj-1,22) 
+            END DO
+         END DO
+         DO jj = mj0(102), mj1(102)                 !* 141,102 (Med side)   (div <0)
+            DO ji = mi0(141), mi1(141) 
+               DO jk = 1, 14                             ! surface flow from Atlantic to Med sea
+                  ta(ji,jj,jk) = ta(ji,jj,jk) - hdiv_141_102_kt(jk) * tn(ji-2,jj-1,jk)
+                  sa(ji,jj,jk) = sa(ji,jj,jk) - hdiv_141_102_kt(jk) * sn(ji-2,jj-1,jk)
+               END DO
+               !                                         ! deeper flow from Med sea to Atlantic
+               ta(ji,jj,21) = ta(ji,jj,21) - hdiv_141_102(21) * tn(ji,jj,21)
+               sa(ji,jj,21) = sa(ji,jj,21) - hdiv_141_102(21) * sn(ji,jj,21)
+            END DO
+         END DO
+         !                  ! ---------------- !
+      CASE( 'spg' )         !  update (ua,va)  ! (call by dynspg module)
+         !                  ! --------=======- !
+         ! at this stage, (ua,va) are the after velocity, not the tendancy
+         ! compute the velocity from the divergence at T-point
+         !
+         DO jj = mj0(101), mj1(101)            !** 139,101 (Atlantic side, south point)
+            DO ji = mi0(139), mi1(139)                    ! div >0 => ua >0, same sign
+               ua(ji,jj,:) = hdiv_139_101_kt(:) / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,:) )   &
+                  &                             * e2u(ji,jj) * fse3u(ji,jj,:)
+            END DO
+         END DO
+         DO jj = mj0(102), mj1(102)            !** 139,102 (Atlantic side, north point)
+            DO ji = mi0(139), mi1(139)                    ! div <0 => ua <0, same sign
+               ua(ji,jj,:) = hdiv_139_102(:) / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,:) )   &
+                  &                          * e2u(ji,jj) * fse3u(ji,jj,:)   
+            END DO
+         END DO
+         DO jj = mj0(102), mj1(102)            !** 140,102 (Med side) (140 not 141 as it is a U-point)
+            DO ji = mi0(140), mi1(140)                    ! div >0 => ua <0, opposite sign
+               ua(ji,jj,:) = - hdiv_141_102(:) / ( e1t(ji+1,jj) * e2t(ji+1,jj) * fse3t(ji+1,jj,:) )   &
+                  &                            * e2u(ji,jj) * fse3u(ji,jj,:)
+            END DO
+         END DO
+         !
+      END SELECT
+      !
+   END SUBROUTINE cla_gibraltar
+
+
+   SUBROUTINE cla_hormuz( cd_td )
+      !! -------------------------------------------------------------------
+      !!                   ***  ROUTINE div_hormuz  ***
+      !!              
+      !! ** Purpose :   update the now horizontal divergence, the tracer 
+      !!              tendancyand the after velocity in vicinity of Hormuz 
+      !!              strait ( Persian Gulf - Indian ocean ).
+      !!
+      !! ** Method  :   Hormuz strait
+      !!            ______________   
+      !!            |/////|<==      surface inflow
+      !!        94  |/////|     
+      !!            |/////|==>      deep    outflow
+      !!            |_____|_______
+      !!              171    172     
       !!---------------------------------------------------------------------
-      !!               ***  ROUTINE tra_gibraltar  ***
-      !!
-      !! ** Purpose :
-      !!        Update the horizontal advective trend of tracers (t & s)
-      !!        correction in Gibraltar  and
-      !!        add it to the general trend of tracer equations.
-      !!
-      !! ** Method :
-      !!      We impose transport at Gibraltar and knowing T and S in
-      !!      surface and deeper at each side of the strait, we deduce T and S
-      !!      of the outflow of the Mediterranean Sea in the Atlantic ocean .
-      !!                                
-      !!          ________________      N        ________________
-      !! 102           |    |->         |           <-|    |<-
-      !! 101      ___->|____|_____   W - - E     ___->|____|_____
-      !!           139   140  141       |         139   140  141
-      !!          horizontal view       S        horizontal view
-      !!            surface                          depth
-      !!         C A U T I O N : the trend saved is the centered trend only.
-      !!      It doesn't take into account the upstream part of the scheme.
-      !!
-      !! ** history :
-      !!           !  02-06  (A. Bozec) Original code 
-      !!      8.5  !  02-11  (A. Bozec) F90: Free form and module
+      CHARACTER(len=1), INTENT(in) ::   cd_td   ! ='ini' initialisation
+      !!                                        ! ='div' update the divergence
+      !!                                        ! ='tra' update the tracers
+      !!                                        ! ='spg' update after velocity
+      !!
+      INTEGER  ::   ji, jj, jk   ! dummy loop indices
+      REAL(wp) ::   zio_flow     ! temporary scalar
       !!---------------------------------------------------------------------
-      !! * Local declarations
-      INTEGER ::  ji, jj, jk               ! dummy loop indices
-      REAL(wp) :: zsu, zvt
-      REAL(wp) :: zsumt, zsumt1, zsumt2, zsumt3, zsumt4
-      REAL(wp) :: zsums, zsums1, zsums2, zsums3, zsums4
-      REAL(wp) :: zt, zs
-      REAL(wp) :: zwei
-      REAL(wp), DIMENSION (jpk) ::  zu1_ms, zu2_ms, zu3_ms
-      !!---------------------------------------------------------------------
-      
-      ! Initialization of vertical sum for T and S transport
-      ! ----------------------------------------------------
-
-      zsumt  = 0.e0        ! West Gib. surface south point ( T )
-      zsums  = 0.e0        ! West Gib. surface south point ( S )
-      zsumt1 = 0.e0        ! East Gib. surface north point ( T )
-      zsums1 = 0.e0        ! East Gib. surface north point ( S )
-      zsumt2 = 0.e0        ! East Gib. depth   north point ( T )
-      zsums2 = 0.e0        ! East Gib. depth   north point ( S )
-      zsumt3 = 0.e0        ! West Gib. depth   south point ( T ) 
-      zsums3 = 0.e0        ! West Gib. depth   south point ( S ) 
-      zsumt4 = 0.e0        ! West Gib. depth   north point ( T ) 
-      zsums4 = 0.e0        ! West Gib. depth   north point ( S ) 
-      
-      ! EMP of Mediterranean Sea 
-      ! ------------------------
- 
-      zempmed = 0.e0
-      zwei = 0.e0
-      DO jj = mj0(96),mj1(110)
-         DO ji = mi0(141),mi1(181)
-            zwei    = tmask(ji,jj,1) * e1t(ji,jj) * e2t(ji,jj)
-            zempmed = zempmed + ( emp(ji,jj) - rnf(ji,jj) ) * zwei 
-         END DO
-      END DO
-      IF( lk_mpp )   CALL mpp_sum( zempmed )      ! sum with other processors value
-
-
-      ! minus 2 points in Red Sea and 3 in Atlantic ocean
-      DO jj = mj0(96),mj1(96)
-         DO ji = mi0(148),mi1(148)
-            zempmed = zempmed  -  ( emp(ji  ,jj)-rnf(ji  ,jj) ) * tmask(ji  ,jj,1) * e1t(ji  ,jj) * e2t(ji  ,jj)   & 
-                               -  ( emp(ji+1,jj)-rnf(ji+1,jj) ) * tmask(ji+1,jj,1) * e1t(ji+1,jj) * e2t(ji+1,jj)    
-         END DO
-      END DO
-
-      ! convert in m3
-      zempmed = zempmed * 1.e-3
-
-      ! Velocity profile at each point
-      ! ------------------------------
-
-      zu1_ms(:) = zu1_ms_i(:)
-      zu2_ms(:) = zu2_ms_i(:)
-      zu3_ms(:) = zu3_ms_i(:)
-
-      ! velocity profile at 139,101  South point + (emp-rnf) on surface 
-      DO jk = 1, 14                      
-         DO jj = mj0(102), mj1(102) 
-            DO ji = mi0(140), mi1(140) 
-               zu1_ms(jk) = zu1_ms(jk) + ( zempmed / 14. ) / ( e2u(ji-1, jj-1) * fse3u(ji-1, jj-1,jk) ) 
-            END DO
-         END DO
-      END DO
-
-      ! profile at East Gibraltar    
-      ! velocity profile at 141,102  + (emp-rnf) on surface 
-      DO  jk = 1, 14                     
-         DO jj = mj0(102), mj1(102) 
-            DO ji = mi0(140), mi1(140) 
-               zu3_ms(jk) = zu3_ms(jk) +  ( zempmed / 14. ) / ( e2u(ji, jj) * fse3u(ji, jj,jk) ) 
-            END DO
-         END DO
-      END DO
-     
-      ! Balance of temperature and salinity
-      ! -----------------------------------
-
-      ! west gibraltar surface vertical sum of transport* S,T
-      DO  jk =  1, 14 
-         DO jj = mj0(101), mj1(101) 
-            DO ji = mi0(139), mi1(139) 
-               zsumt  = zsumt + tn(ji, jj,jk) * e2u(ji, jj) * fse3u(ji, jj,jk) * zu1_ms(jk)  
-               zsums  = zsums + sn(ji, jj,jk) * e2u(ji, jj) * fse3u(ji, jj,jk) * zu1_ms(jk) 
-            END DO
-         END DO
-      END DO
-
-      ! east Gibraltar surface  vertical sum of transport* S,T
-      DO  jk =  1, 14 
-         DO jj = mj0(101), mj1(101) 
-            DO ji = mi0(139), mi1(139) 
-               zsumt1 = zsumt1 + tn(ji, jj,jk) * e2u(ji+1, jj+1) * fse3u(ji+1, jj+1,jk) * zu3_ms(jk)
-               zsums1 = zsums1 + sn(ji, jj,jk) * e2u(ji+1, jj+1) * fse3u(ji+1, jj+1,jk) * zu3_ms(jk)
-            END DO
-         END DO
-      END DO
-
-      ! east Gibraltar deeper  vertical sum of transport* S,T
-      DO jj = mj0(102), mj1(102) 
-         DO ji = mi0(141), mi1(141) 
-            zsumt2 = tn(ji, jj,21) * e2u(ji-1, jj) * fse3u(ji-1, jj,21) * zu3_ms(21)
-            zsums2 = sn(ji, jj,21) * e2u(ji-1, jj) * fse3u(ji-1, jj,21) * zu3_ms(21)
-         END DO
-      END DO
-      
-      ! west Gibraltar deeper vertical sum of transport* S,T
-      DO  jk =  21, 22 
-         DO jj = mj0(101), mj1(101) 
-            DO ji = mi0(139), mi1(139) 
-               zsumt3 = zsumt3 + tn(ji, jj,jk) * e2u(ji, jj) * fse3u(ji, jj,jk) * zu1_ms(jk)
-               zsums3 = zsums3 + sn(ji, jj,jk) * e2u(ji, jj) * fse3u(ji, jj,jk) * zu1_ms(jk)
-            END DO
-         END DO
-      END DO
-
-      ! Total transport = 0.
-      zsumt4 = zsumt2 + zsumt1 - zsumt - zsumt3
-      zsums4 = zsums2 + zsums1 - zsums - zsums3
-
-      ! Temperature and Salinity at West gibraltar , Level 22
-      DO jj = mj0(102), mj1(102) 
-         DO ji = mi0(140), mi1(140) 
-            zt = zsumt4 / ( zu2_ms(22) * e2u(ji-1, jj) * fse3u(ji-1, jj, 22) )
-            zs = zsums4 / ( zu2_ms(22) * e2u(ji-1, jj) * fse3u(ji-1, jj, 22) )
-         END DO
-      END DO
-      
-      ! New Temperature and Salinity trend at West Gibraltar
-      ! ----------------------------------------------------
-
-      ! south point 	
-      DO jk = 1, 22
-         DO jj = mj0(101), mj1(101) 
-            DO ji = mi0(139), mi1(139) 
-               zvt = e1t(ji, jj) * e2t(ji, jj) * fse3t(ji, jj,jk)
-               zsu = e2u(ji, jj) * fse3u(ji, jj,jk)
-               ta(ji, jj,jk) = ta(ji, jj,jk) - ( 1. / zvt ) * zsu * zu1_ms(jk) * tn(ji, jj,jk)
-               sa(ji, jj,jk) = sa(ji, jj,jk) - ( 1. / zvt ) * zsu * zu1_ms(jk) * sn(ji, jj,jk)
-            END DO
-         END DO
-      END DO
-
-      ! north point 
-      DO jk = 15, 20
-         DO jj = mj0(102), mj1(102) 
-            DO ji = mi0(139), mi1(139) 
-               zvt = e1t(ji, jj) * e2t(ji, jj) * fse3t(ji, jj,jk)
-               zsu = e2u(ji, jj) * fse3u(ji, jj,jk)
-               ta(ji, jj,jk) = ta(ji, jj,jk) - ( 1. / zvt ) * zsu * zu2_ms(jk) * tn(ji, jj-1,jk)
-               sa(ji, jj,jk) = sa(ji, jj,jk) - ( 1. / zvt ) * zsu * zu2_ms(jk) * sn(ji, jj-1,jk)
-            END DO
-         END DO
-      END DO
-
-      ! Gibraltar outflow, north point deeper
-      jk =  22
-      DO jj = mj0(102), mj1(102) 
-         DO ji = mi0(139), mi1(139) 
-            zvt = e1t(ji, jj) * e2t(ji, jj) * fse3t(ji, jj,jk)
-            zsu = e2u(ji, jj) * fse3u(ji, jj,jk)
-            ta(ji, jj,jk) = ta(ji, jj,jk) - ( 1. / zvt ) * zsu * zu2_ms(jk) * zt
-            sa(ji, jj,jk) = sa(ji, jj,jk) - ( 1. / zvt ) * zsu * zu2_ms(jk) * zs
-         END DO
-      END DO
-
-
-      ! New Temperature and Salinity at East Gibraltar 
-      ! ----------------------------------------------
-
-      ! surface	
-      DO jk = 1, 14
-         DO jj = mj0(102), mj1(102) 
-            DO ji = mi0(141), mi1(141) 
-               zvt = e1t(ji, jj) * e2t(ji, jj) * fse3t(ji, jj,jk)
-               zsu = e2u(ji-1, jj) * fse3u(ji-1, jj,jk)
-               ta(ji, jj,jk) = ta(ji, jj,jk) + ( 1. / zvt ) * zsu * zu3_ms(jk) * tn(ji-2, jj-1,jk)
-               sa(ji, jj,jk) = sa(ji, jj,jk) + ( 1. / zvt ) * zsu * zu3_ms(jk) * sn(ji-2, jj-1,jk)
-            END DO
-         END DO
-      END DO
-      ! deeper
-      jk =  21
-      DO jj = mj0(102), mj1(102) 
-         DO ji = mi0(141), mi1(141) 
-            zvt = e1t(ji, jj) * e2t(ji, jj) * fse3t(ji, jj,jk)
-            zsu = e2u(ji-1, jj) * fse3u(ji-1, jj,jk)
-            ta(ji, jj,jk) = ta(ji, jj,jk) + ( 1. / zvt ) * zsu * zu3_ms(jk) * tn(ji, jj,jk)
-            sa(ji, jj,jk) = sa(ji, jj,jk) + ( 1. / zvt ) * zsu * zu3_ms(jk) * sn(ji, jj,jk)
-         END DO
-      END DO
-
-   END SUBROUTINE tra_gibraltar
-
-
-   SUBROUTINE tra_hormuz
-      !!---------------------------------------------------------------------
-      !!               ***  ROUTINE tra_hormuz  ***
-      !!
-      !! ** Purpose :   Update the horizontal advective trend of tracers
-      !!        correction in Hormuz.
-      !!
-      !! ** Method :   We impose transport at Hormuz .
-      !!                                
-      !! ** history :
-      !!           !  02-11  (A. Bozec) Original code 
-      !!      8.5  !  02-11  (A. Bozec) F90: Free form and module
-      !!---------------------------------------------------------------------
-      !! * Local declarations
-      INTEGER ::  ji, jj, jk              ! dummy loop indices
-      REAL(wp) :: zsu, zvt
-      !!---------------------------------------------------------------------
-      
-      ! New trend at Hormuz strait
-      ! --------------------------
-      DO jk = 1, 8   
-         DO jj = mj0(94), mj1(94) 
+      !
+      SELECT CASE( cd_td ) 
+      !                     ! ---------------- !
+      CASE( 'ini' )         !  initialisation  ! 
+         !                  ! ---------------- ! 
+         !                                     !** profile of horizontal divergence due to cross-land advection
+         zio_flow  = 1.e6                          ! imposed in/out flow
+         !
+         hdiv_172_94(:) = 0.e0         
+         !
+         DO jj = mj0(94), mj1(94)                  ! in/out flow at (i,j) = (172,94)
             DO ji = mi0(172), mi1(172) 
-               zvt = e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk)
-               zsu = e2u(ji-1,jj) * fse3u(ji-1,jj,jk)
-               ta(ji,jj,jk) = ta(ji,jj,jk) + ( 1. / zvt ) * zsu * zu_pg(jk) * tn(ji,jj,jk) 
-               sa(ji,jj,jk) = sa(ji,jj,jk) + ( 1. / zvt ) * zsu * zu_pg(jk) * sn(ji,jj,jk) 
-            END DO
-         END DO
-      END DO
-      DO jk = 16, 18
-         DO jj = mj0(94), mj1(94) 
+               DO jk = 1, 8                            ! surface inflow  (Indian ocean to Persian Gulf) (div<0)
+                  hdiv_172_94(jk) = - ( zio_flow / 8.e0 * e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
+               END DO
+               DO jk = 16, 18                          ! deep    outflow (Persian Gulf to Indian ocean) (div>0)
+                  hdiv_172_94(jk) = + ( zio_flow / 3.e0 * e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
+               END DO
+            END DO
+         END DO
+         !                                     !** T & S profile in the Hormuz strait (use in deep outflow)
+         !      Temperature       and         Salinity
+         t_171_94_hor(:)  = 0.e0   ;   s_171_94_hor(:)  = 0.e0
+         t_171_94_hor(16) = 18.4   ;   s_171_94_hor(16) = 36.27
+         t_171_94_hor(17) = 17.8   ;   s_171_94_hor(17) = 36.4
+         t_171_94_hor(18) = 16.    ;   s_171_94_hor(18) = 36.27
+         !
+         !                  ! ---------------- !
+      CASE( 'div' )         !   update hdivn   ! (call by divcur module)
+         !                  ! ---------=====-- ! 
+         !                                   
+         DO jj = mj0(94), mj1(94)              !** 172,94 (Indian ocean side)
             DO ji = mi0(172), mi1(172) 
-               zvt = e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk)
-               zsu = e2u(ji-1,jj) * fse3u(ji-1,jj,jk)
-               ta(ji,jj,jk) = ta(ji,jj,jk) + ( 1. / zvt ) * zsu * zu_pg(jk) * zthor(jk)
-               sa(ji,jj,jk) = sa(ji,jj,jk) + ( 1. / zvt ) * zsu * zu_pg(jk) * zshor(jk)
-            END DO
-         END DO
-      END DO
-
-   END SUBROUTINE tra_hormuz
-
-
-   SUBROUTINE tra_cla_init
-      !!---------------------------------------------------------------------
-      !!               ***  ROUTINE tra_cla_init  ***
-      !!
-      !! ** Purpose :   Initialization of variables
-      !!
-      !! ** history :
-      !!      9.0  !  02-11  (A. Bozec) Original code
-      !!---------------------------------------------------------------------
-      !! * Local declarations
-      INTEGER ::  ji, jj, jk              ! dummy loop indices
-      !!---------------------------------------------------------------------
-
-      ! Control print
-      ! -------------
-
-      IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) 'tra_cla_init : cross land advection on tracer '
-      IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~'
-
-      ! Initialization at Bab el Mandeb
-      ! -------------------------------
-
-      ! imposed transport
-      zisw_rs = 0.4e6        ! inflow surface water
-      zurw_rs = 0.2e6        ! upper recirculation water
-!!Alex      zbrw_rs = 1.2e6        ! bottom  recirculation water
-      zbrw_rs = 0.5e6        ! bottom  recirculation water
-
-      ! initialization of the velocity at Bab el Mandeb
-      zu1_rs_i(:) = 0.e0      ! velocity profile at 161,88 South point
-      zu2_rs_i(:) = 0.e0      ! velocity profile at 161,87 North point
-      zu3_rs_i(:) = 0.e0      ! velocity profile at 160,88 East  point
-
-      ! velocity profile at 161,88 East Bab el Mandeb North point 
-      ! we imposed zisw_rs + EMP above the Red Sea 
-      DO jk = 1, 8                                      
-         DO jj = mj0(88), mj1(88) 
-            DO ji = mi0(160), mi1(160) 
-               zu1_rs_i(jk) = -( zisw_rs / 8. ) / ( e2u(ji,jj) * fse3u(ji,jj,jk) )     
-            END DO
-         END DO
-      END DO
-
-      ! recirculation water 
-      DO jj = mj0(88), mj1(88) 
-         DO ji = mi0(160), mi1(160) 
-            zu1_rs_i(20) = -(           zurw_rs ) / ( e2u(ji,jj) * fse3u(ji,jj,20) )
-            zu1_rs_i(21) = -( zbrw_rs - zurw_rs ) / ( e2u(ji,jj) * fse3u(ji,jj,21) )
-         END DO
-      END DO
-      
-      ! velocity profile at 161,87 East Bab el Mandeb South point
-      DO jj = mj0(87), mj1(87) 
-         DO ji = mi0(160), mi1(160) 
-            zu2_rs_i(21) =  ( zbrw_rs + zisw_rs ) / ( e2u(ji,jj) * fse3u(ji,jj,21) )
-         END DO
-      END DO
-
-      ! velocity profile at 161, 88 West Bab el Mandeb 
-      ! we imposed zisw_rs + EMP above the Red Sea 
-      DO jk = 1,  10                                     
-         DO jj = mj0(88), mj1(88) 
-            DO ji = mi0(160), mi1(160) 
-               zu3_rs_i(jk) =  ( zisw_rs / 10. ) / ( e1v(ji,jj) * fse3v(ji,jj,jk) )
-            END DO
-         END DO
-      END DO
-
-      ! deeper
-      DO jj = mj0(88), mj1(88) 
-         DO ji = mi0(160), mi1(160) 
-            zu3_rs_i(16)  = - zisw_rs /( e1v(ji,jj) * fse3v(ji,jj,16) )
-         END DO
-      END DO
-
-
-      ! Initialization at Gibraltar
-      ! ---------------------------
-
-      ! imposed transport
-      zisw_ms = 0.8e6         ! atlantic-mediterranean  water
-      zmrw_ms = 0.7e6         ! middle recirculation water
-      zurw_ms = 2.5e6         ! upper  recirculation water 
-      zbrw_ms = 3.5e6         ! bottom recirculation water 
-
-      ! initialization of the velocity
-      zu1_ms_i(:) = 0.e0       ! velocity profile at 139,101 South point
-      zu2_ms_i(:) = 0.e0       ! velocity profile at 139,102 North point
-      zu3_ms_i(:) = 0.e0       ! velocity profile at 141,102 East  point
-
-      ! velocity profile at 139,101  South point
-      DO jk = 1, 14                      
-         DO jj = mj0(102), mj1(102) 
-            DO ji = mi0(140), mi1(140) 
-               zu1_ms_i(jk) = ( zisw_ms / 14. ) / ( e2u(ji-1, jj-1) * fse3u(ji-1, jj-1,jk)) 
-            END DO
-         END DO
-      END DO
-
-      ! middle recirculation ( uncounting in the balance )
-      DO jk = 15, 20                      
-         DO jj = mj0(102), mj1(102) 
-            DO ji = mi0(140), mi1(140) 
-               zu1_ms_i(jk) = ( zmrw_ms / 6. ) / ( e2u(ji-1, jj-1) * fse3u(ji-1, jj-1,jk) ) 
-            END DO
-         END DO
-      END DO
-
-      DO jj = mj0(102), mj1(102) 
-         DO ji = mi0(140), mi1(140) 
-            zu1_ms_i(21) =  (           zurw_ms ) / ( e2u(ji-1, jj-1) * fse3u(ji-1, jj-1,21) )
-            zu1_ms_i(22) =  ( zbrw_ms - zurw_ms ) / ( e2u(ji-1, jj-1) * fse3u(ji-1, jj-1,22) )
-         END DO
-      END DO
-
-      ! velocity profile at 139,102  North point
-      ! middle recirculation ( uncounting in the balance )
-      DO jk = 15, 20                      
-         DO jj = mj0(102), mj1(102) 
-            DO ji = mi0(140), mi1(140) 
-               zu2_ms_i(jk) = -( zmrw_ms / 6. ) / ( e2u(ji-1, jj) * fse3u(ji-1, jj,jk) ) 
-            END DO
-         END DO
-      END DO 
-
-      DO jj = mj0(102), mj1(102) 
-         DO ji = mi0(140), mi1(140) 
-            zu2_ms_i(22) = -( zisw_ms + zbrw_ms ) / ( e2u(ji-1, jj) * fse3u(ji-1, jj,22) )
-         END DO
-      END DO 
-
-      ! profile at East Gibraltar   
-      ! velocity profile at 141,102 
-      DO  jk = 1, 14                     
-         DO jj = mj0(102), mj1(102) 
-            DO ji = mi0(140), mi1(140) 
-               zu3_ms_i(jk) =  ( zisw_ms / 14. ) / ( e2u(ji, jj) * fse3u(ji, jj,jk) ) 
-            END DO
-         END DO
-      END DO
-
-      ! deeper 
-      DO jj = mj0(102), mj1(102) 
-         DO ji = mi0(140), mi1(140) 
-            zu3_ms_i(21) = -zisw_ms / ( e2u(ji, jj) * fse3u(ji, jj,21) )
-         END DO
-      END DO
-
-
-      ! Initialization at Hormuz
-      ! ------------------------
-
-      ! imposed transport
-      zisw_pg = 4. * 0.25e6      ! surface and bottom  water
-
-      ! initialization of the velocity
-      zu_pg(:) = 0.e0       ! velocity profile at 139,101 South point
-
-      ! Velocity profile 
-      DO jk = 1, 8 
-         DO jj = mj0(94), mj1(94) 
+               hdivn(ji,jj,:) = hdivn(ji,jj,:) + hdiv_172_94(:)
+            END DO
+         END DO
+         !                  ! ---------------- !
+      CASE( 'tra' )         !  update (ta,sa)  ! (call by traadv module)
+         !                  ! --------=======- !
+         !                          
+         DO jj = mj0(94), mj1(94)              !** 172,94 (Indian ocean side)
             DO ji = mi0(172), mi1(172) 
-               zu_pg(jk) = -( zisw_pg / 8. ) /  ( e2u(ji-1,jj) * fse3u(ji-1,jj,jk) )
-            END DO
-         END DO
-      END DO
-     DO jk = 16, 18
-         DO jj = mj0(94), mj1(94) 
-            DO ji = mi0(172), mi1(172) 
-               zu_pg(jk) =  ( zisw_pg / 3. )  / ( e2u(ji-1,jj) * fse3u(ji-1,jj,jk) )
-            END DO
-         END DO
-      END DO
-
-      ! Temperature and Salinity at Hormuz
-      zthor(:) = 0.e0
-      zshor(:) = 0.e0
-
-      zthor(16) = 18.4
-      zshor(16) = 36.27
-      !
-      zthor(17) = 17.8
-      zshor(17) = 36.4
-      !
-      zthor(18) = 16.
-      zshor(18) = 36.27
- 
-   END SUBROUTINE tra_cla_init
-
+               DO jk = 1, 8                          ! surface inflow   (Indian ocean to Persian Gulf) (div<0)
+                  ta(ji,jj,jk) = ta(ji,jj,jk) - hdiv_172_94(jk) * tn(ji,jj,jk) 
+                  sa(ji,jj,jk) = sa(ji,jj,jk) - hdiv_172_94(jk) * sn(ji,jj,jk) 
+               END DO
+               DO jk = 16, 18                        ! deep outflow     (Persian Gulf to Indian ocean) (div>0)
+                  ta(ji,jj,jk) = ta(ji,jj,jk) - hdiv_172_94(jk) * t_171_94_hor(jk)
+                  sa(ji,jj,jk) = sa(ji,jj,jk) - hdiv_172_94(jk) * s_171_94_hor(jk)
+               END DO
+            END DO
+         END DO
+         !                  ! ---------------- !
+      CASE( 'spg' )         !  update (ua,va)  ! (call by dynspg module)
+         !                  ! --------=======- !
+         ! No barotropic flow through Hormuz strait
+         ! at this stage, (ua,va) are the after velocity, not the tendancy
+         ! compute the velocity from the divergence at T-point
+         DO jj = mj0(94), mj1(94)              !** 171,94 (Indian ocean side) (171 not 172 as it is the western U-point)
+            DO ji = mi0(171), mi1(171)                ! div >0 => ua >0, opposite sign
+               ua(ji,jj,:) = - hdiv_172_94(:) / ( e1t(ji+1,jj) * e2t(ji+1,jj) * fse3t(ji+1,jj,:) )   &
+                  &                           * e2u(ji,jj) * fse3u(ji,jj,:)
+            END DO
+         END DO
+         !
+      END SELECT
+      !
+   END SUBROUTINE cla_hormuz
+   
 #else
    !!----------------------------------------------------------------------
-   !!   Default option                              NO cross land advection
+   !!   Default key                                            Dummy module
    !!----------------------------------------------------------------------
-   USE in_out_manager  ! I/O manager
+   USE in_out_manager ! I/O manager
 CONTAINS
-   SUBROUTINE tra_cla_init 
-   END SUBROUTINE tra_cla_init
-   SUBROUTINE tra_cla( kt ) 
-      INTEGER, INTENT(in) ::   kt    ! ocean time-step indice
-      IF( kt == nit000 .AND. lwp ) THEN
-         WRITE(numout,*)
-         WRITE(numout,*) 'tra_cla : No use of cross land advection'
-         WRITE(numout,*) '~~~~~~~'
-      ENDIF
-   END SUBROUTINE tra_cla
+   SUBROUTINE cla_init
+      CALL ctl_stop( 'cla_init: Cross Land Advection hard coded for ORCA_R2 with 31 levels' )
+   END SUBROUTINE cla_init
+   SUBROUTINE cla_div( kt )
+      WRITE(*,*) 'cla_div: You should have not see this print! error?', kt
+   END SUBROUTINE cla_div
+   SUBROUTINE cla_traadv( kt ) 
+      WRITE(*,*) 'cla_traadv: You should have not see this print! error?', kt
+   END SUBROUTINE cla_traadv
+   SUBROUTINE cla_dynspg( kt ) 
+      WRITE(*,*) 'dyn_spg_cla: You should have not see this print! error?', kt
+   END SUBROUTINE cla_dynspg
 #endif
-
+   
    !!======================================================================
 END MODULE cla
